Index: squid/src/HintCachePrim.c
diff -u /dev/null squid/src/HintCachePrim.c:1.1.2.2
--- /dev/null	Mon Jan 26 04:57:38 2004
+++ squid/src/HintCachePrim.c	Mon May 20 19:46:42 2002
@@ -0,0 +1,404 @@
+/*
+ * $Date: 2004/08/17 20:55:13 $ $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * DEBUG: section 89    List of known caches.
+ * AUTHOR: Mike Dahlin, UT Austin, 1998
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * --------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by
+ *  the National Science Foundation.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  
+ */
+/*
+ *------------------------------------------------------------------
+ * LESS Group 
+ * Computer Sciences Department 
+ * University of Texas at Austin
+ *
+ * HCPrimitives.h --- Primitive types for hint cache.
+ *------------------------------------------------------------------
+ */
+#include "squid.h"
+#include <assert.h>
+
+
+const URLKey INVALID_URL_KEY = { 0 };
+
+static HintCacheKey calculateStupidKey(char *url);
+static void makeLowerCase(char *url);
+
+const static int useMD5 = 1;
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * URLKey --
+ *
+ *          The first 64 bits of the 128-bit Squid/Cache Digest URL key.
+ */
+
+
+
+/*
+ * Make lower case, but stop at third '/' (e.g., after the hostname).
+ */
+static void
+makeLowerCase(char *url)
+{
+    int len, ii;
+    int slashCount = 0;
+
+    assert(url);
+    len = strlen(url);
+    for (ii = 0; ii < len; ii++) {
+	/*
+	 * Alignment.
+	 */
+	if (url[ii] == '/') {
+	    slashCount++;
+	    if (slashCount == 3) {
+		return;
+	    }
+	}
+	url[ii] = tolower(url[ii]);
+    }
+}
+
+
+/* functional encapsulation of the ever-popular macro of the
+   same name.  Needed for hash table. */
+int 
+hintCacheURLKeyCompare(URLKey *u1, URLKey *u2)
+{
+    return(URLKEY_COMPARE(*u1, *u2));
+}
+
+/*
+ * Retrieve entry using hint_table.
+ * The hint_table keeps a pointer to the hchash part of th
+ * StoreEntry, so we apply the appropriate offset to
+ * retrieve the StoreEntry itself.
+ */
+StoreEntry *
+hintCacheStoreGet(URLKey urlkey)
+{
+    hash_link *hchash;
+    StoreEntry *entry;
+    int hchoff;
+    
+    hchash = (hash_link *) hash_lookup(store_table, &urlkey);
+    hchoff = (u_char *) &entry->hchash - (u_char *) entry;
+    entry = (StoreEntry *) ((u_char *) hchash - hchoff);
+    return(entry);
+}
+
+
+void
+hintCacheNetURLKeyNetInit(URLKeyNet * mungedKey, URLKey * key)
+{
+    mungedKey->mungedKey = hintCacheEndian_llMachineToNet(key->key);
+}
+
+void
+hintCacheNetURLKeyLocalFormat(URLKeyNet * mungedKey, URLKey * key)
+{
+    key->key = hintCacheEndian_llNetToMachine(mungedKey->mungedKey);
+}
+
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * NodeKey --
+ *
+ *          A <key, struct sockaddr_in> pair (plus stuff to
+ *          put it on a list.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *---------------------------------------------------4.9.1998--------
+ */
+void
+hintCacheNodeKeyInit(NodeKey * k, const struct sockaddr_in *addrP)
+{
+    assert(k);
+    assert(addrP);
+
+    k->links.data = k;
+    k->links.next = k->links.prev = 0;
+    k->key = hintCacheNodeKeyKey(addrP);
+    k->addr = *addrP;
+}
+
+int
+hintCacheNodeKeyCompare(const NodeKey * k1, const NodeKey * k2)
+{
+    assert(k1);
+    assert(k2);
+    if (k1->key != k2->key) {
+	return 1;
+    }
+    return 0;
+}
+
+struct sockaddr_in
+hintCacheNodeKeyGetAddr(const NodeKey * k)
+{
+    assert(k);
+    return k->addr;
+}
+
+HintCacheKey
+hintCacheNodeKeyKey(const struct sockaddr_in * addrP)
+{
+    HintCacheKey k;
+    char *name;
+
+    name = inet_ntoa(addrP->sin_addr);
+    k = *(HintCacheKey *) storeKeyPublic(name, METHOD_PUT);
+    return k;
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * hintCacheEntry --
+ *
+ *          A structure including a <URLKey, sockaddr_in> pair. Generally
+ *          points to the nearest copy of the specified url.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+void
+hintCacheEntryInit(HintCacheEntry * entry, URLKey key, struct sockaddr_in *saddr,
+    unsigned int mtime)
+{
+    entry->key = key;
+    entry->ipaddr = saddr->sin_addr;
+    entry->port = saddr->sin_port;
+    entry->pad = 0;
+    entry->mtime = mtime;
+}
+
+int
+hintCacheEntryCompare(HintCacheEntry * e1, HintCacheEntry * e2)
+{
+    /* 
+     * If you add a field, you must change this code.
+     */
+    if (URLKEY_COMPARE(e1->key, e2->key)) {
+	return 1;
+    }
+
+    if (e1->ipaddr.s_addr != e2->ipaddr.s_addr)
+	return 1;
+
+    if (e1->port != e2->port)
+	return 1;
+
+    if (e1->mtime != e2->mtime)
+	return 1;
+
+    return 0;
+}
+
+void
+hintCacheNetEntryInit(HintCacheEntryNet * mungedEntry, HintCacheEntry * entry)
+{
+    /* 
+     * If you add a field, you must change this code.
+     */
+    URLKeyNetInit(&mungedEntry->mungedKey, &entry->key);
+/*  mungedEntry->mungedIpaddr.s_addr  = htonl(entry->ipaddr.s_addr);*/
+    mungedEntry->mungedIpaddr.s_addr = entry->ipaddr.s_addr;
+    mungedEntry->mungedPort = htons(entry->port);
+    mungedEntry->mungedMtime = htonl(entry->mtime);
+}
+
+void
+hintCacheEntryLocalFormatNet(HintCacheEntryNet * mungedEntry, HintCacheEntry * entry)
+{
+    /* 
+     * If you add a field, you must change this code.
+     */
+    URLKeyLocalFormatNet(&mungedEntry->mungedKey, &entry->key);
+/*  entry->ipaddr.s_addr = ntohl(mungedEntry->mungedIpaddr.s_addr);*/
+    entry->ipaddr.s_addr = mungedEntry->mungedIpaddr.s_addr;
+    entry->port = ntohs(mungedEntry->mungedPort);
+    entry->mtime = htonl(mungedEntry->mungedMtime);
+}
+
+
+/*
+ *------------------------------------------------------------------
+ *
+ * HCUpdate --
+ *
+ *          An update is a HintCacheEntry and an action.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+void
+hintCacheUpdateInit(HintCacheUpdate * u, int action, HintCacheEntry * entry, int hopcount)
+{
+    u->action = action;
+    u->hopcount = hopcount;
+    u->UNUSED = 0;		/* remove this field sometime */
+    u->entry = *entry;
+}
+
+void
+hintCacheUpdateSelfTest()
+{
+    HintCacheUpdate update;
+    HintCacheUpdateNet netupd;
+
+    /* HintCacheUpdate must be at least this min size */
+    assert(sizeof(HintCacheUpdate) >= HCU_MINLEN);
+
+    /* Test that some field in update has expected offset */
+    assert((char *) &update.entry - (char *) &update == 8);
+    assert((char *) &netupd.mungedEntry - (char *) &netupd == 8);
+
+    /* Make sure net version of struct stays in sync. */
+    assert(sizeof(HintCacheUpdate) == sizeof(HintCacheUpdateNet));
+}
+
+void
+hintCacheUpdateInitNet(HintCacheUpdateNet * mupdate, HintCacheUpdate * update)
+{
+    /* No need for htonl on action, hopcount, or len - they are single bytes. */
+    mupdate->mungedAction = update->action;
+    mupdate->mungedUNUSED = update->UNUSED;	/* remove this field sometime */
+    mupdate->mungedHopcount = update->hopcount;
+    mupdate->mungedPad1 = -1;
+    mupdate->mungedPad2 = -1;
+/*     mupdate->mungedCchange  = htonl(update->cchange); XXX - NOTYET */
+
+    hintCacheEntryInitNet(&mupdate->mungedEntry, &update->entry);
+}
+
+
+void
+hintCacheUpdateLocalFormatNet(HintCacheUpdateNet * mupdate, HintCacheUpdate * update)
+{
+    /* No need for htonl on action or len - they are single bytes. */
+    update->action = mupdate->mungedAction;
+    update->UNUSED = mupdate->mungedUNUSED;;
+    update->hopcount = mupdate->mungedHopcount;
+/*     update->cchange  = ntohl(mupdate->mungedCchange); XXX - NOTYET */
+
+    hintCacheEntryLocalFormatNet(&mupdate->mungedEntry, &update->entry);
+}
+
+int
+hintCacheUpdateCompare(HintCacheUpdate * u1, HintCacheUpdate * u2)
+{
+    if ((u1->action != u2->action)
+	|| (u1->hopcount != u2->hopcount)
+	|| (hintCacheEntry_Compare(&u1->entry, &u2->entry))) {
+	return 1;
+    }
+    return 0;
+}
+
+#ifdef DOTEST
+/*
+ *------------------------------------------------------------------
+ *
+ * primitivesSelfTest --
+ *
+ *          description.
+ *
+ * Arguments:
+ *      type1 arg1 -- description.
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      None.
+ *
+ *------------------------------------------------------------------
+ */
+void
+primitivesSelfTest()
+{
+
+    URLKey urlKey, urlKey2;
+    URLKeyNet netUrlKey;
+    char url[128];
+    HintCachEntry hcEntry, hcEntry2;
+    HintCacheEntry netHintCacheEntry;
+    HintCacheUpdate hcUpdate, hcUpdate2;
+    HintCacheUpdateNet netHintCacheUpdate;
+    struct sockaddr_in saddr = { AF_INET, 0, {{{0, 0, 0, 0}}} };
+
+    printf("primitivesSelfTest()..");
+
+    sprintf(url, "http://www.cs.Utexas.edu");
+    hintCacheURLKey_Init(&urlKey, url);
+    Net_URLKey_Init(&netUrlKey, &urlKey);
+    URLKeyLocalFormatNet(&netUrlKey, &urlKey2);
+    assert(!URLKEY_COMPARE(urlKey, urlKey2));
+
+    hintCacheEntryInit(&hcEntry, urlKey, &saddr);
+    hintCacheEntryInitNet(&netHintCacheEntry, &hcEntry);
+    hintCacheEntryLocalFormatNet(&netHintCacheEntry, &hcEntry2);
+    assert(!hintCacheEntryCompare(&hcEntry, &hcEntry2));
+
+    hintCacheUpdateInit(&hcUpdate, HC_InvalToChild, &hcEntry, 1);
+    hintCacheUpdate_selfTest();
+    hintCacheUpdateInitNet(&netHintCacheUpdate, &hcUpdate);
+    hintCacheUpdateLocalFormatNet(&netHintCacheUpdate, &hcUpdate2);
+    assert(!HintCacheUpdate_Compare(&hcUpdate, &hcUpdate2));
+
+    printf(".OK\n");
+}
+#endif /* DOTEST */
Index: squid/src/Makefile.am
diff -u squid/src/Makefile.am:1.24 squid/src/Makefile.am:1.8.2.5
--- squid/src/Makefile.am:1.24	Sun Sep  1 09:30:40 2002
+++ squid/src/Makefile.am	Tue Sep  3 10:41:32 2002
@@ -52,6 +52,32 @@
 SSLSOURCE = 
 endif
 
+if ENABLE_HINTS
+HINTSOURCE = \
+	HintCache.c \
+	HintCacheDisk.c \
+	HintCacheEndian.c \
+	HintCacheHier.c \
+	HintCacheNet.c \
+	HintCacheNodes.c \
+	HintCachePrim.c \
+	HintCacheProp.c
+else
+HINTSOURCE=
+endif
+
+if ENABLE_PLAXTON
+PLAXSOURCE = Plaxton.c
+else
+PLAXSOURCE =
+endif
+
+if ENABLE_ICP_DATA
+ICPDATASOURCE = icp_data.c
+else
+ICPDATASOURCE =
+endif
+
 if ENABLE_WIN32SPECIFIC
 WIN32SOURCE = win32.c
 else
@@ -74,6 +100,7 @@
 	squid
 
 bin_PROGRAMS = \
+	webpush \
 	squidclient
 
 libexec_PROGRAMS = \
@@ -122,6 +149,7 @@
 	defines.h \
 	$(DELAY_POOL_SOURCE) \
 	disk.c \
+        dist.c \
 	$(DNSSOURCE) \
 	enums.h \
 	errorpage.c \
@@ -136,6 +164,7 @@
 	globals.h \
 	gopher.c \
 	helper.c \
+	$(HINTSOURCE) \
 	$(HTCPSOURCE) \
 	http.c \
 	HttpStatusLine.c \
@@ -151,6 +180,7 @@
 	icmp.c \
 	icp_v2.c \
 	icp_v3.c \
+	$(ICPDATASOURCE) \
 	ident.c \
 	internal.c \
 	ipc.c \
@@ -168,7 +198,9 @@
 	pconn.c \
 	peer_digest.c \
 	peer_select.c \
+	$(PLAXSOURCE) \
 	protos.h \
+	put.c \
 	redirect.c \
 	referer.c \
 	refresh.c \
@@ -283,6 +315,7 @@
 DEFAULT_ICON_DIR	= $(datadir)/icons
 DEFAULT_ERROR_DIR	= $(datadir)/errors/@ERR_DEFAULT_LANGUAGE@
 DEFAULT_MIB_PATH	= $(datadir)/mib.txt
+DEFAULT_HINT_FILE       = $(DEFAULT_SWAP_DIR)/hints
 DEFAULT_HOSTS		= @OPT_DEFAULT_HOSTS@
 
 DEFS = @DEFS@ -DDEFAULT_CONFIG_FILE=\"$(DEFAULT_CONFIG_FILE)\"
@@ -333,6 +366,7 @@
 	s%@DEFAULT_ICON_DIR@%$(DEFAULT_ICON_DIR)%g;\
 	s%@DEFAULT_MIB_PATH@%$(DEFAULT_MIB_PATH)%g;\
 	s%@DEFAULT_ERROR_DIR@%$(DEFAULT_ERROR_DIR)%g;\
+	s%@DEFAULT_HINT_FILE@%$(DEFAULT_HINT_FILE)%g;\
 	s%@DEFAULT_PREFIX@%$(DEFAULT_PREFIX)%g;\
 	s%@DEFAULT_HOSTS@%$(DEFAULT_HOSTS)%g;"\
 	< $(srcdir)/cf.data.pre >$@
